<?php
if (!defined('PmWiki'))
	exit ();

/**
 * Initilize Xajax
 * 
 * @author Patrick R. Michaud <pmichaud@pobox.com> 
 * @author Sebastian Siedentopf <schlaefer@macnews.de>
 * @copyright by the authors 2005
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License
 * @version 0.2
 * @package xajaxpmwikiglue
 */

define(XAJAXPMWIKIGLUE, "0.2");

Markup('insertxajaxargs', '>directives', '/\\(:XajaxArgs:\\)/e', "XajaxSetAllArgumentsFromPhp()");
/**
 * We call this function to output the $XajaxArgs. 
 * This is a global variable in PmWiki which can be used 
 * to initilize parameters in ParseArgs() style. 
 * The div is then used to pass parameters between 
 * xajax functions by not using $_SESSION.
 * <br> 
 * You have to execute XajaxSetAllArgumentsFromPhp() <b>once</b>
 * One way is to set (:XajaxArgs:) on your wikipage. 
 * The easiest way ist to  set 
 * <!--markup:(:XajaxArgs:)--> before your </body> 
 * tag in yours skin .tmpl file.
 */
function XajaxSetAllArgumentsFromPhp() {
	global $XajaxArgs;
	return "<div id='xajaxargs' style='display:none;'>".GenerateArgs($XajaxArgs)."</div>";
}

/**
 * Generates a plain string from a ParseArgs() result.
 * $args == GenerateArgs(ParseArgs($args))
 * Not well testet for all kinds of possible args
 * @version 0.1
 * @param array $args
 * return string
 */
function GenerateArgs($args) {
	if (!isset ($args))
		return "";
	foreach ($args as $k => $v) {
		if ($k == '#')
			continue;
		elseif ($k === '' && !is_array($v)) $out .= " $v";
		elseif ($k === '+' || $k === '-') foreach ($v as $w)
			$out .= " $k$w";
		elseif (is_array($v)) continue;
		else
			$out .= " $k='$v'";
	}
	return $out;
}

require_once ("xajax.inc.php");
$xajax = new xajax();
// $xajax->debugOn();
$HTMLHeaderFmt['xajaxInit'] = "\n".$xajax->getJavascript();

if (!empty ($_GET['xajax']) || !empty ($_POST['xajax'])) {
	include_once ("$FarmD/scripts/stdconfig.php");

	## we generate the $LinkFunctions for the generation of the $LinkPattern
	global $InterMapFiles, $LinkFunctions, $IMap;
	foreach ((array) $InterMapFiles as $f) {
		if (@ !($mapfd = fopen($f, "r")))
			continue;
		while ($mapline = fgets($mapfd, 1024)) {
			if (preg_match('/^\\s*(#|$)/', $mapline))
				continue;
			list ($imap, $url) = preg_split('/\\s+/', $mapline);
			if (strpos($url, '$1') === false)
				$url .= '$1';
			$LinkFunctions["$imap:"] = 'LinkIMap';
			$IMap["$imap:"] = FmtPageName($url, $pagename);
		}
	}

	# we have to build $LinkPattern here, if we do not
	# the link markup fails to build in MarkupToHtml()->BuildMarkupRules()
	global $LinkPattern, $LinkFunctions;
	$LinkPattern = implode('|', array_keys($LinkFunctions));

}

if (isset ($XajaxInclude) && is_array($XajaxInclude))
	foreach ($XajaxInclude as $filename)
		include_once ("$FarmD/cookbook/".$filename.".common.php");

$xajax->processRequests();

?>