<?php
if (!defined('PmWiki') || !defined('XAJAXPMWIKIGLUE'))
	exit ();

/**
 * This package replace the pmwiki search function view a new one
 * which allows to preview pages
 * <br>
 * This file contains function which are called by PmWiki itself or XAJAX 
 *   
 * @author Patrick R. Michaud <pmichaud@pobox.com> 
 * @author Sebastian Siedentopf <schlaefer@macnews.de>
 * @version 0.2.1
 * @link 
 * @copyright by the authors 2005
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License
 * @package xajaxsearch
 */
 
define(XAJAXSEARCH, '0.2.1');
$xajax->registerFunction("ajaxFmtPageList");
$xajax->registerFunction("ajaxShowPage");
$xajax->registerFunction("ajaxShowWaitWheelInDiv");
require_once ("xajaxsearch.server.php");

$HTMLHeaderFmt['xajaxSearch'] = "
		<script type=\"text/javascript\">
		function submitSearch()
		{   xajax_ajaxShowWaitWheelInDiv('searchresultsajax',\"<div class='previewname'>".FmtPageName("$[Search]...",$pagename)."</div>\");
			xajax.$('submitButton').disabled=true;
			xajax_ajaxFmtPageList(xajax.getFormValues('ajaxSearchForm'),document.getElementById('xajaxargs').innerHTML);
			return false;
		}
		
		function showPreview(pagename)
		{   xajax_ajaxShowWaitWheelInDiv('previewpage');
			xajax_ajaxShowPage(pagename,document.getElementById('xajaxargs').innerHTML);
			return false;
		}

		function deleteAllChilds(n) {           
				var n = document.getElementById(n)
				var childs = n.childNodes;  
				var numchilds = childs.length;  
		 	for(var i = numchilds-1; i >= 0; i--) { 
   				 var c = n.removeChild(childs[i]);   
				}
		}
		</script>";

SDV($HTMLStylesFmt['xajaxsearch'], " 
	/*the ajax search form*/
	.searchformajaxouter {
		padding:5px; 
		margin-left:2px;
		border:1px silver solid; 
		postion:relative; width: 785px; }
	.searchformajaxinner {
		padding:10px 5px 10px 5px;
		border:1px silver solid; 
		background-color: #cccccc; 
		color:white; font-weight:bold; 
		font-size:normal;
		text-align: right; }
	/* the ajax search output*/
	.ajaxsearchtable { 
		position:relative; }
	/*the ajax searchresults on the left*/
	.searchresultsajax { 
		width:270px; 
		border:1px silver solid; 
		padding:5px;  }
	/*the ajax search preview on the right*/
	.previewcontainer {
		padding:5px; 
		border:1px silver solid; 
		 }
	.previewname { 
		padding:20px 10px 20px 10px; 
		margin:0px 0px 20px 0px; 
		border:1px silver solid; 
		background-color:#cccccc; 
		color:white; font-weight:bold; 
		font-size:normal; overflow: auto; }
	.previewpage { overflow: auto; width:500px;  
		}
");

Markup('searchboxajax', '<searchresultsajax', '/\\(:searchboxajax(\\s.*?)?:\\)/e', "SearchBoxAjax(\$pagename, ParseArgs(PSS('$1')))");
Markup('searchresultsajax', '<searchresults', '/\\(:searchresultsajax(\\s+.*?)?:\\)/ei', "SearchResultsAjax(\$pagename)");

/**
 * Outputs the search form
 * 
 * @param string $pagename
 * @param string $opt
 * @return string html search form 
 */
function SearchBoxAjax($pagename, $opt) {
	global $SearchBoxFmt, $SearchBoxOpt, $SearchQuery, $EnablePathInfo;
	if (isset ($SearchBoxFmt))
		return FmtPageName($SearchBoxFmt, $pagename);
	SDVA($SearchBoxOpt, array ('size' => '40', 'label' => FmtPageName('$[Search]', $pagename), 'group' => @ $_REQUEST['group'], 'value' => $SearchQuery));
	$opt = array_merge((array) $SearchBoxOpt, (array) $opt);
	$group = $opt['group'];
	$out[] = FmtPageName("<form id='ajaxSearchForm' name='ajaxSearchForm' class='wikisearch' action='javascript:void(null);' style='display:none;' onsubmit='submitSearch();'>", $pagename);
	if (!IsEnabled($EnablePathInfo, 0))
		$out[] = "<input type='hidden' name='n' value='$pagename' />";
	if ($group)
		$out[] = "<input type='hidden' name='group' value='$group' />";
	$out[] = "<input type='hidden' name='pagename' value='$pagename' /><div class='searchformajaxouter'> <div class='searchformajaxinner'> ";
	$out[] = $opt['label'].": <input type='text' name='searchterm' value='{$opt['value']}'  size='{$opt['size']}' />";
	$out[] = "<input type='submit' class='wikisearchbutton' id='submitButton' name='submitButton'  value='{$opt['label']}' /></div></div></form>";
	$out[] = "<script type=\"text/javascript\">document.getElementById('ajaxSearchForm').style.display = 'inline'; </script>";
	return Keep(implode("", $out));
}

/**
 * Outputs the placeholder for the inserted ajax string and handles searches
 * by normal pmwiki search query
 * 
 * @param string $pagename
 * @return string	
 */
function SearchResultsAjax($pagename) {
	global $XajaxArgs;
	
	if (isset ($_REQUEST['q'])) { # perform search if it came in with default search query 
		$output = searchPerformAjax($_REQUEST['n'], $_REQUEST['q']);
	} else
		$output = "<div class ='previewname'>".FmtPageName("$[Search Results]", $pagename)."</div>";

	$out = "	
					<table class='ajaxsearchtable'><tr><td style=' vertical-align:top;' class='searchresultsajax'>
					<div id='searchresultsajax' >
						$output
					</div>
					</td><td style=' vertical-align:top;' class='previewcontainer'>
						<div id='previewname' class='previewname' >".FmtPageName("$[Preview]", $pagename)."</div>
						<div id='previewpage' class='previewpage'></div>\n
					</td></tr></table>
				";

	$XajaxArgs["searchterm"] = $_REQUEST['q'];
	$XajaxArgs["oldpagename"] = "empty";
	
	$nojs = Keep("<div id='javascriptdisabled'>")."(:searchbox:)".Keep("<br/><b>".FmtPageName("$[Please activate JavaScript to use all search features!]",$pagename)."</b><br/><br/></div>");
	$out .= "<script type=\"text/javascript\">deleteAllChilds('javascriptdisabled');</script>";

	return $nojs.Keep($out);
}



/**
 * Performs the search and outputs in the the search results in ajaxsearch style
 * 
 * @param string $pagename
 * @param string $searchterm
 * @return string list of found items in html
*/
function searchPerformAjax($pagename, $searchterm) {
	## redefines with custom style class
	global $SearchResultsFmt;
	$SearchResultsFmt = "<div class='previewname'>\$[SearchFor]</div>
				  		$HTMLVSpace\$MatchList
				  		<br/>$HTMLVSpace\$[SearchFound]$HTMLVSpace";

	## new formating for generation the preview links
	global $FPLByGroupIFmt, $FPLByGroupGFmt;
	SDV($FPLByGroupIFmt, "
						<dd id='dd\$Group.\$Name' style='white-space: nowrap;'>
						<a style='font-size:smaller;' href=\"javascript:void(null)\" onclick=\"showPreview('\$Group.\$Name')\">".FmtPageName("$[Preview]",$pagename)."</a> -
						<a href='\$PageUrl'>\$Name</a>
						</dd>\n");
	SDV($FPLByGroupGFmt, "
			<dt style='background-color:#cccccc;display:block; margin:5px 0px 0px 0px; padding:3px;'>
				<a style='color:white; font-weight:bold;' href='\$ScriptUrl/\$Group'>\$Group /</a>
			</dt>\n
		");

	$fmt = FmtPageName($GLOBALS['SearchResultsFmt'], $pagename);

	#FmtPageList requests q for the search term
	$_REQUEST['q'] = $searchterm;

	# after the search delete the surrounding <div>
	$out = preg_replace("/<\/?div>/", "", FmtPageList($fmt, $pagename, array ('o' => '', 'req' => 1)));

	$out = MarkupToHtml($pagename, $out);
	
	return $out;
	
}

?>